<?php
	require_once( $C->INCPATH.'helpers/func_api.php' );
	require_once( $C->INCPATH.'classes/class_oauth.php' );
	
	global $user;
	
	$uri = $this->param('more');
	$format = $this->param('format');
	$oauth_status = false;	
	$bauth_status = false;
	$header = prepare_header();

	if( $auth = check_if_basic_auth() ) 
	{
		$res = $user->login( $auth[0], md5($auth[1]) );
		if( ! $res ) {
			$oauth_error = 'Invalid Authorization header.';
		}
		
		if($user->is_logged) $bauth_status = true;
	}elseif(isset($_GET['oauth_consumer_key']))
	{
		if(isset($_GET['oauth_version']) && $_GET['oauth_version'] != '1.0') $oauth_error = 'Not supported OAuth version';
		elseif(isset($_GET['oauth_consumer_key'], $_GET['oauth_nonce'], $_GET['oauth_token'],
				$_GET['oauth_signature_method'], $_GET['oauth_signature'], $_GET['oauth_timestamp']))
		{ 
			if(!isset($uri[0]))
			{
				$oauth_error = 'Invalid address.';
				exit;
			}
			$oauth_client = new OAuth($_GET['oauth_consumer_key'], $_GET['oauth_nonce'], $_GET['oauth_token'],
				$_GET['oauth_timestamp'], $_GET['oauth_signature']);
				
			$oauth_client->set_variable('stage_url', $C->SITE_URL.'1/statuses/'.$uri[0].'.'.$format);
			
			if($oauth_client->is_valid_get_resource_request())
			{
				if($_GET['oauth_signature_method'] != 'HMAC-SHA1') $oauth_error = 'Unsupported signature method';
				elseif(!$oauth_client->decrypt_hmac_sha1()) $oauth_error = 'Invalid signature';		
				else 
				{
					$oauth_status = true;
				}
				
			}$oauth_error =  $oauth_client->get_variable('error_msg');		
		}else $oauth_error = 'Missing OAuth parameters';
	}else 
	{
		if(!$header) $oauth_error = 'Invalid Authorization header.';
		elseif(isset($header['oauth_version']) && $header['oauth_version'] != '1.0') $oauth_error = 'Not supported OAuth version';
		elseif(isset($header['oauth_consumer_key'], $header['oauth_nonce'], $header['oauth_token'],
				$header['oauth_signature_method'], $header['oauth_signature'], $header['oauth_timestamp']))
		{	
			$oauth_client = new OAuth($header['oauth_consumer_key'], $header['oauth_nonce'], $header['oauth_token'],
				$header['oauth_timestamp'], $header['oauth_signature']);
				
			$oauth_client->set_variable('stage_url', $C->SITE_URL.'1/direct_messages');
			
			if($oauth_client->is_valid_get_resource_request())
			{
				if($header['oauth_signature_method'] != 'HMAC-SHA1') $oauth_error = 'Unsupported signature method';
				elseif(!$oauth_client->decrypt_hmac_sha1()) $oauth_error = 'Invalid signature';		
				else
				{
					$oauth_status = true;
				}
			}$oauth_error =  $oauth_client->get_variable('error_msg');		
		}else $oauth_error = 'Missing OAuth parameters';
	}
	
	if(isset($_REQUEST['callback']) && valid_fn($_REQUEST['callback'])) $callback = $_REQUEST['callback'];
		else $callback = FALSE;

	if($format != 'xml' && $format != 'json')
	{		
		if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
			else echo generate_error($format, 'Invalid data format requested.', $_SERVER['REQUEST_URI'], $callback);

		exit;
	}elseif(isset($uri[0]) && $uri[0] == 'new')
	{
		if($_SERVER['REQUEST_METHOD'] != 'POST'  || ($format != 'xml' && $format != 'json'))
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error('xml', 'Invalid request method or data format.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_status && !$bauth_status)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
				else echo generate_error($format, 'OAuth otorization problem: '.$oauth_error, $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
	
		if($oauth_status)
		{
			$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
											'access_token', urldecode($header['oauth_token'])));
			$app_id = $oauth_client->get_value_in_consumer_key('app_id');
			if(!$id || !$app_id)
			{
				if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
					else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			if(!$oauth_client->check_access_type('rw'))
			{
				if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 403 Forbidden');
					else echo generate_error($format, 'You have no permission for this action.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			
			$u = $this->network->get_user_by_id($id);
			if(!$u)
			{
				if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'Invalid user id.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			
			$user->logout();
			$user->login($u->username, $u->password); 
		
		}elseif($bauth_status)
		{
			$id = $user->id;
			$app_id = 1;
		}
		
		if(isset($_POST['user_id']) && is_numeric($_POST['user_id'])) $to_id = intval($_POST['user_id']);
		elseif(isset($_POST['screen_name']))
		{
			$u = $this->network->get_user_by_username(urldecode($_POST['screen_name']));
			if(!$u)
			{
				if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'Invalid username.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			$to_id = $u->id;
		}else
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Parameter required.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if(!isset($_POST['text']) || empty($_POST['text']))
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid text parameter.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		$_POST['text'] = htmlspecialchars(stripslashes(urldecode($_POST['text'])));
		
		
		if( !$user->is_logged ) 
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage N1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}elseif($to_id == $id)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid user id.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		$r = $db2->query('SELECT message FROM posts_pr WHERE user_id='.intval($id).' ORDER BY id DESC LIMIT 1');
		if($db2->num_rows($r) > 0) 
		{
			$obj = $db2->fetch_object($r); 
			if($obj->message == $_POST['text'])
			{
				if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'Provide different message.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
		}
		
		$newpost	= new newpost();
		$newpost->set_api_id( $app_id );
		$newpost->set_to_user( $to_id ); 
		$newpost->set_message( $_POST['text'] );
		$ok	= $newpost->save();
		if( !$ok ) 
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage N2).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		else 
		{
			$p_id = explode("_", $ok);
			$res = $db2->query('SELECT id AS pid, user_id, to_user, message, date FROM posts_pr WHERE id=\''.intval($p_id[0]).'\' LIMIT 1');
			if($db2->num_rows($res) == 0) 
			{
				if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
					else echo generate_error($format, 'Server error (Stage 22).', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			$fr = $db2->fetch_object($res);
					
			$answer = generate_header($format, $callback, $id);		
				$answer .= generate_section($format, 'direct-message');

					$answer .= generate_field($format, 'id', $fr->pid);
					$answer .= generate_field($format, 'sender_id', $id);
					$answer .= generate_field($format, 'text', $fr->message);
					$answer .= generate_field($format, 'recipient_id', $to_id);
					$answer .= generate_field($format, 'created_at', date('D M d H:i:s +0000 Y', $fr->date));
					$answer .= generate_field($format, 'sender_screen_name', 'none');
					$answer .= generate_field($format, 'recipient_screen_name', 'none');
					$answer = ($format == 'json')? substr($answer, 0, -1) : $answer;	
						$answer .= generate_section($format, 'sender');
							$answer .= print_user($id, $format);
						$answer .= generate_section($format, 'sender', TRUE);
				
						$answer .= generate_section($format, 'recipient');
							$answer .= print_user($to_id, $format);
						$answer .= generate_section($format, 'recipient', TRUE);
				
				$answer .= generate_section($format, 'direct-message', TRUE);
			$answer .= generate_bottom($format, $callback);
			
			echo $answer;
			exit;
		}	
	}elseif(isset($uri[0]) && $uri[0] == 'destroy')
	{
		if(($_SERVER['REQUEST_METHOD'] != 'POST'  && $_SERVER['REQUEST_METHOD'] != 'DELETE') || ($format != 'xml' && $format != 'json'))
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error('xml', 'Invalid request method or data format.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_status && !$bauth_status)
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
				else echo generate_error($format, 'OAuth otorization problem: '.$oauth_error, $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		if($oauth_status)
		{
			$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
											'access_token', urldecode($header['oauth_token'])));
			if(!$id)
			{
				if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
					else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			
			if(!$oauth_client->check_access_type('rw'))
			{
				if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Forbidden');
					else echo generate_error($format, 'You have no permission forthis action.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			$u = $this->network->get_user_by_id($id);
			if(!$u)
			{
				if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
					else echo generate_error($format, 'Server Error (Stage PD1).', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
		
			$user->logout();
			$user->login($u->username, $u->password); 
		}elseif($bauth_status)
		{
			$id = $user->id;
		}
		
		if( !$user->is_logged ) 
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage 3).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if(isset($uri[1])) $m_id = intval($uri[1]);
		else
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid id parameter.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		$private_post = new post('private', $m_id);	
		
		if(!$private_post)
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 500 Bad Request');
				else echo generate_error($format, 'Post author authenticating problem.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		$answer = generate_header($format, $callback, $id);		
			$answer .= generate_section($format, 'direct-message');
		
				$answer .= generate_field($format, 'id', $private_post->post_id);
				$answer .= generate_field($format, 'sender_id', $private_post->post_user->id);
				$answer .= generate_field($format, 'recepient_id', $private_post->post_to_user->id);
				$answer .= generate_field($format, 'text', $private_post->post_message);
				$answer .= generate_field($format, 'created_at', gmdate('D M d H:i:s \+0000 Y',$private_post->post_date));
				$answer .= generate_field($format, 'sender_screen_name', 'none');
				$answer .= generate_field($format, 'recipient_screen_name', 'none');
				
				$answer = ($format == 'json')? substr($answer, 0, -1) : $answer;	
		
					$answer .= generate_section($format, 'sender');
						$answer .= print_user($private_post->post_user->id, $format);
					$answer .= generate_section($format, 'sender', TRUE);
		
					$answer .= generate_section($format, 'recipient');
						$answer .= print_user($private_post->post_to_user->id, $format);
					$answer .= generate_section($format, 'recipient', TRUE);
		
			$answer .= generate_section($format, 'direct-message', TRUE);
		$answer .= generate_bottom($format, $callback);
		
		if($private_post->delete_this_post())
		{
			echo $answer;
			exit;
		}else
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage 4).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}	
	}else
	{
		if($_SERVER['REQUEST_METHOD'] != 'GET')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid request method.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_status && !$bauth_status)
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
				else echo generate_error($format, 'OAuth otorization problem: '.$oauth_error, $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if($oauth_status)
		{
			$oauth_token = (isset($header['oauth_token']))? $header['oauth_token']:$_GET['oauth_token'];
			
			$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 'access_token', urldecode($oauth_token)));
			
			if(!$id)
			{
				if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
					else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			
			$u = $this->network->get_user_by_id($id);
			if(!$u)
			{
				if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
					else echo generate_error($format, 'Server Error (Stage PD1).', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
		
			$user->logout();
			$user->login($u->username, $u->password); 
		}elseif($bauth_status) $id = $user->id;

		if(isset($uri[0]) && $uri[0] == 'sent')	
			$q = 'SELECT id, user_id, to_user, message, date  FROM posts_pr WHERE user_id =\''.intval($id).'\'';
		else
			$q = 'SELECT id, user_id, to_user, message, date  FROM posts_pr WHERE to_user =\''.intval($id).'\'';
		
		$q .= ' ORDER BY id';	
		
		if(isset($_GET['count']) && !isset($_GET['page']))
			{if(is_numeric($_GET['count']) && $_GET['count']<200) $q .= ' LIMIT '.intval($_GET['count']);}
		elseif(isset($_GET['page']) && !isset($_GET['count']))
			{if(is_numeric($_GET['page'])) $q .= ' LIMIT '.(20)*(intval($_GET['page'])-1).', '.(20)*(intval($_GET['page']));}
		elseif(isset($_GET['page']) && isset($_GET['count']))
			{
			if(is_numeric($_GET['page']) && is_numeric($_GET['count'])) 
				$q .= ' LIMIT '.(intval($_GET['count']))*(intval($_GET['page'])-1).', '.(intval($_GET['count']))*(intval($_GET['page']));
			}
		else $q .= ' LIMIT 20';

		$res = $db2->query($q); 
		$num_rows = $db2->num_rows($res);
		
		if($num_rows > 0)
		{	
			$answer = generate_header($format, $callback, $id);			
			$answer .= generate_section($format, 'direct-messages');
				
				$i = 1;
				while($message = $db2->fetch_object($res))
				{
					$answer .= generate_it_en($format);	
					$answer .= generate_section($format, 'direct-message');
						
						$answer .= generate_field($format, 'id', $message->id);
						$answer .= generate_field($format, 'sender_id', $message->user_id);
						$answer .= generate_field($format, 'text', $message->message);
						$answer .= generate_field($format, 'recipient_id', $message->to_user);
						$answer .= generate_field($format, 'created_at', gmdate('D M d H:i:s \+0000 Y', $message->date));
						$answer .= generate_field($format, 'sender_screen_name', 'none');
						$answer .= generate_field($format, 'recipient_screen_name', 'none');
						
						$answer .= generate_section($format, 'sender');
							$answer .= print_user($message->user_id, $format);
						$answer .= generate_section($format, 'sender', TRUE);
					
						$answer .= ($format == 'json')? ',' : '';	
						$answer .= generate_section($format, 'recipient');
							$answer .= print_user($message->to_user, $format);
						$answer .= generate_section($format, 'recipient', TRUE);
					
					$answer .= generate_section($format, 'direct-message', TRUE);
					$answer .= ($format == 'json' && $i<$num_rows)? ',' : '';
							
					$answer .= generate_it_en($format);
					$i++;
				}
			
			$answer .= generate_section($format, 'direct-messages', TRUE);			
			$answer .= generate_bottom($format, $callback);
			
			echo $answer;
			exit;
		}else
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 304 Not Modified');
				else echo generate_error($format, 'No results found.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
	}	
	if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 404 Not Found');
		else echo generate_error($format, 'Invalid resource request', $_SERVER['REQUEST_URI'], $callback);
	exit;
?>