<?php
	require_once( $C->INCPATH.'helpers/func_api.php' );
	require_once( $C->INCPATH.'classes/class_oauth.php' );
	
	global $user;
	
	$uri = $this->param('more');
	$format = $this->param('format');
	$oauth_status = false;
	$bauth_status = false;
	$header = prepare_header();
	
	if( $auth = check_if_basic_auth() ) {
		$res = $user->login( $auth[0], md5($auth[1]) );
		if( ! $res ) {
			$oauth_error = 'Invalid Authorization header.';
		}
		if($user->is_logged) $bauth_status = true;
	}
	else 
	{	
		if(!$header) $oauth_error = 'Invalid Authorization header.';
		elseif(isset($header['oauth_version']) && $header['oauth_version'] != '1.0') $oauth_error = 'Not supported OAuth version';
		elseif(isset($header['oauth_consumer_key'], $header['oauth_nonce'], $header['oauth_token'],
				$header['oauth_signature_method'], $header['oauth_signature'], $header['oauth_timestamp']))
		{	
			$oauth_client = new OAuth($header['oauth_consumer_key'], $header['oauth_nonce'], $header['oauth_token'],
				$header['oauth_timestamp'], $header['oauth_signature']);
				
			$oauth_client->set_variable('stage_url', $C->SITE_URL.'1/favorites');
			
			if($oauth_client->is_valid_get_resource_request())
			{
				if($header['oauth_signature_method'] != 'HMAC-SHA1') $oauth_error = 'Unsupported signature method';
				elseif(!$oauth_client->decrypt_hmac_sha1()) $oauth_error = 'Invalid signature';		
				else
				{
					$oauth_status = true;
				}
			}$oauth_error =  $oauth_client->get_variable('error_msg');		
		}else $oauth_error = 'Missing OAuth parameters';
	}
	if($format != 'xml' && $format != 'json')
	{		
		if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
			else echo generate_error('xml', 'Invalid data format requested.', $_SERVER['REQUEST_URI'], $callback);
		exit;
	}
	
	if(isset($_REQUEST['callback']) && valid_fn($_REQUEST['callback'])) $callback = $_REQUEST['callback'];
		else $callback = FALSE;

	if(!$oauth_status && !$user->is_logged)
	{
		if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
			else echo generate_error($format, 'OAuth otorization problem: '.$oauth_error, $_SERVER['REQUEST_URI'], $callback);
		exit;
	}elseif(isset($uri[0]) && ($uri[0] == 'create' || $uri[0] == 'destroy'))
	{
		if($_SERVER['REQUEST_METHOD'] != 'POST' && $_SERVER['REQUEST_METHOD'] != 'DELETE' && $_SERVER['REQUEST_METHOD'] != 'GET')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid request method.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}elseif($format != 'xml' && $format != 'json')
		{		
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error('xml', 'Invalid data format requested.', $_SERVER['REQUEST_URI'], $callback);
	
			exit;
		}
		if($oauth_status)
		{
			$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
											'access_token', urldecode($header['oauth_token'])));
			if(!$id)
			{
				if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
					else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			
			if(!$oauth_client->check_access_type('rw'))
			{
				if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 403 Forbidden');
					else echo generate_error($format, 'You have no permission for this action.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			
			if(!$oauth_client->check_rate_limits($id, 1))
			{
				if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'You have no available rate limits, try again later.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
	
			$u	= $this->network->get_user_by_id($id);
			if(!$u)
			{
				if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
					else echo generate_error($format, 'Server error (Stage CD1).', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			$res = $user->login( $auth[0], md5($auth[1]) );
			if( ! $res ) {
				if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
					else echo generate_error($format, 'Server error (Stage CD22).', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
		}elseif($bauth_status) $id = $user->id;
		
		if(!isset($uri[1]) || !is_numeric($uri[1]))
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid favorite id parameter.', $_SERVER['REQUEST_URI'], $callback);
			exit;	
		}	
		
		$post	= new post('public', intval($uri[1]));
		
		if($uri[0] == 'create') $res = $post->fave_post();
			else $res = $post->fave_post(FALSE);
		
		if($res)
		{
			$answer = generate_header($format, $callback, $id);		
				$answer .= generate_section($format, 'status');		
					$answer .= print_status(intval($uri[1]), $format);
						$answer .= generate_section($format, 'user');
							$answer .= print_user($post->post_user->id, $format);
						$answer .= generate_section($format, 'user', TRUE);
				$answer .= generate_section($format, 'status', TRUE);
			$answer .= generate_bottom($format, $callback);
			
			echo $answer;
			exit;
		}else
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 500 Bad Request');
				else echo generate_error($format, 'Invalid favorite id.', $_SERVER['REQUEST_URI'], $callback);
			exit;	
		}
		
	}elseif(isset($this->request[0]) && $this->request[0] == 'favorites' && !isset($uri[0]))
	{
		if($_SERVER['REQUEST_METHOD'] != 'GET')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid request method.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if($oauth_status)
		{
			$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
											'access_token', urldecode($header['oauth_token'])));	
			if(!$id)
			{
				if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
					else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
		}elseif($user->is_logged) $id = $user->id;
		
		$q = 'SELECT post_id FROM post_favs WHERE user_id=\''.intval($id).'\' ORDER BY date DESC';
		if(isset($_GET['page']) && is_numeric($_GET['page'])) 
			$q .= ' LIMIT '.(20)*(intval($_GET['page'])-1).', '.(20)*(intval($_GET['page']));
		else
			$q .= ' LIMIT 20';

		$res = $db2->query($q);
		
		if($db2->num_rows($res) > 0)
		{
			global $user;
			$user	= new stdClass;
			$user->id	= $id;
			$user->is_logged	= TRUE;
		
			$answer = generate_header($format, $callback, $id);
			$answer .= generate_section($format, 'statuses');				
				while($fav = $db2->fetch_object($res))
				{
					$answer .= generate_it_en($format);	
					$answer .= generate_section($format, 'status');
						$answer .= print_status($fav->post_id, $format);
					
							$answer .= generate_section($format, 'user');
								
								$usr = $db2->query('SELECT user_id FROM posts WHERE id="'.$fav->post_id.'" LIMIT 1');
								$usr = $db2->fetch_object($usr);		
								$answer .= print_user($usr->user_id, $format);
								
							$answer .= generate_section($format, 'user', TRUE);		
					
					$answer .= generate_section($format, 'status', TRUE);	
					$answer .= generate_it_en($format);		
				}
			$answer .= generate_section($format, 'statuses', TRUE);			
			$answer .= generate_bottom($format, $callback);
			
			echo $answer;
			exit;
		}else
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 304 Not Modified');
				else echo generate_error($format, 'No results found.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
	}
	
	if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 404 Not Found');
		else echo generate_error($format, 'Invalid resource request', $_SERVER['REQUEST_URI'], $callback);
	exit;	
?>