<?php
	require_once( $C->INCPATH.'helpers/func_api.php' );
	require_once( $C->INCPATH.'classes/class_oauth.php' );
	
	$uri = $this->param('more');
	$format = $this->param('format');
	
	$oauth_status = false;	

	if(! $header = prepare_header()) $oauth_error = 'Invalid Authorization header.';
	elseif(isset($header['oauth_version']) && $header['oauth_version'] != '1.0') $oauth_error = 'Not supported OAuth version';
	elseif(isset($header['oauth_consumer_key'], $header['oauth_nonce'], $header['oauth_token'],
			$header['oauth_signature_method'], $header['oauth_signature'], $header['oauth_timestamp']))
	{	
		$oauth_client = new OAuth($header['oauth_consumer_key'], $header['oauth_nonce'], $header['oauth_token'],
			$header['oauth_timestamp'], $header['oauth_signature']);
			
		$oauth_client->set_variable('stage_url', $C->SITE_URL.'1/friendships');
		
		if($oauth_client->is_valid_get_resource_request())
		{
			if($header['oauth_signature_method'] != 'HMAC-SHA1') $oauth_error = 'Unsupported signature method';
			elseif(!$oauth_client->decrypt_hmac_sha1()) $oauth_error = 'Invalid signature';		
			else
			{
				$oauth_status = true;
			}
		}$oauth_error =  $oauth_client->get_variable('error_msg');		
	}else $oauth_error = 'Missing OAuth parameters';
	
	$features = array('create', 'destroy', 'exists', 'show', 'incoming', 'outgoing');
	if(isset($_REQUEST['callback']) && valid_fn($_REQUEST['callback'])) $callback = $_REQUEST['callback'];
		else $callback = FALSE;

	if($format != 'xml' && $format != 'json')
	{		
		if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
			else echo generate_error('xml', 'Invalid data format requested.', $_SERVER['REQUEST_URI'], $callback);

		exit;
	}elseif(!isset($uri[0]) || !in_array($uri[0], $features))
	{
		if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
			else echo generate_error($format, 'Invalid feature requested.', $_SERVER['REQUEST_URI'], $callback);
		exit;
	}elseif($uri[0] == 'create' || $uri[0] == 'destroy')
	{	
		if($_SERVER['REQUEST_METHOD'] != 'POST')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error('xml', 'Invalid request method or data format.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_status)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
				else echo generate_error($format, 'OAuth otorization problem: '.$oauth_error, $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		$user_id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
										'access_token', urldecode($header['oauth_token'])));
		$app_id = $oauth_client->get_value_in_consumer_key('app_id');
		if(!$user_id || !$app_id)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_client->check_access_type('rw'))
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Forbidden');
				else echo generate_error($format, 'You have no permission for this action.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if(isset($_POST['user_id']) && is_numeric($_POST['user_id'])) $follow_id = intval($_POST['user_id']);
		elseif(isset($_POST['screen_name']) || (isset($uri[1]) && !is_numeric($uri[1])))
		{
			if(isset($_POST['screen_name'])) $u = $this->network->get_user_by_username(urldecode($_POST['screen_name']));
			else $u = $this->network->get_user_by_username(urldecode($uri[1]));
			if(!$u)
			{
				if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'Invalid username.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			$follow_id = $u->id;
		}elseif(isset($uri[1]) && is_numeric($uri[1])) $follow_id = intval($uri[1]);
		else
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid user id provided.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if(!isset($user_id) || !isset($follow_id) || ($user_id == $follow_id))
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid user ids.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		$u	= $this->network->get_user_by_id($user_id);
		if(!$u)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Server Error (Stage CD1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		global $user;
		$user->logout();
		$user->login($u->username, $u->password); 
		if( ! $user->is_logged ) 
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage CD2).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if($uri[0] == 'create')
		{
			$info	= $this->network->get_user_follows($user_id);
			if(!$info) 
			{
				if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
					else echo generate_error($format, 'Server error (Stage 1).', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}	
			$following	= array_keys($info->follow_users);
			
			if(!in_array($follow_id, $following)) $ok = $user->follow($follow_id);
				else
				{
					if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 403 Forbidden');
						else echo generate_error($format, 'You have already followed this user.', $_SERVER['REQUEST_URI'], $callback);
					exit;	
				}
		}
		elseif($uri[0] == 'destroy')
		{
			$info	= $this->network->get_user_follows($user_id);
			if(!$info) 
			{
				if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
					else echo generate_error($format, 'Server error (Stage V1).', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}	
			$following	= array_keys($info->follow_users);
			
			if(in_array($follow_id, $following)) $ok = $user->follow($follow_id, FALSE);
				else
				{
					if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 403 Forbidden');
						else echo generate_error($format, 'This user is not your friend.', $_SERVER['REQUEST_URI'], $callback);
					exit;
				}	
		}
		
		if( !$ok ) 
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage CD3).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		else {
			$answer = generate_header($format, $callback, $user_id);		
				$answer .= generate_section($format, 'user');		
					$answer .= print_user($user_id, $format);
			
						$q = 'SELECT posts.id AS pid, posts.group_id, groups.id, posts.user_id, posts.date FROM posts, groups ';
						$q .= ' WHERE (posts.group_id = 0 OR posts.group_id = groups.id) AND groups.is_public ';
						$q .= ' AND posts.user_id=\''.intval($user_id).'\'';		
						$answer .= generate_section($format, 'status');
							$answer .= print_status(0, $format, $q);
						$answer .= generate_section($format, 'status', TRUE);
			
				$answer .= generate_section($format, 'user', TRUE);		
			$answer .= generate_bottom($format, $callback);
			
			echo $answer;
			exit;
		}
	}elseif($uri[0] == 'exists')
	{	
		if($_SERVER['REQUEST_METHOD'] != 'GET')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error('xml', 'Invalid request method or data format.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		if(isset($_GET['user_a']) && is_numeric($_GET['user_a'])) $user_a = intval($_GET['user_a']);
		if(isset($_GET['user_b']) && is_numeric($_GET['user_b'])) $user_b = intval($_GET['user_b']);
		
		if(!isset($user_a) || !isset($user_b) || ($user_a == $user_b))
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid user ids.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}else
		{
			if(!check_rate_limits($_SERVER['REMOTE_ADDR'], 1))
			{
				if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'You have no available rate limits, try again later.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			$u = $this->network->get_user_by_id($user_a);
			if(!$u)
			{
				if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'Invalid user.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			
			global $user;
			$user->logout();
			$user->login($u->username, $u->password); 
			if( !$user->is_logged ) 
			{
				if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
					else echo generate_error($format, 'Server error (Stage 3).', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			
			$ok = $user->if_follow_user($user_b);
			
			if( $ok ) $answer = generate_field($format, 'friends', 'true');
				else $answer = generate_field($format, 'friends', 'false');
			
			$answer = ($format == 'json')? substr($answer, 0, -1) : $answer;	
			
			echo $answer;
			exit;	
		}	
	}elseif($uri[0] == 'show')
	{
		if($_SERVER['REQUEST_METHOD'] != 'GET')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid request method or data format.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		if(isset($_GET['source_id']) && is_numeric($_GET['source_id'])) $source_id = intval($_GET['source_id']);
		elseif(isset($_GET['source_screen_name']))
		{
			$u = $this->network->get_user_by_username(urldecode($_GET['source_screen_name']));
			if(!$u)
			{
				if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'Invalid user.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			$source_id = $u->id;
		}		
		if(isset($_GET['target_id']) && is_numeric($_GET['target_id'])) $target_id = intval($_GET['target_id']);
		elseif(isset($_GET['target_screen_name']))
		{
			$u = $this->network->get_user_by_username(urldecode($_GET['target_screen_name']));
			if(!$u)
			{
				if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'Invalid user.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			$target_id = $u->id;
		}else
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'Parameter required.', $_SERVER['REQUEST_URI'], $callback);
				exit;
		}
		
		if(!isset($source_id) || !isset($target_id) || ($source_id == $target_id))
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid user ids.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		if(!check_rate_limits($_SERVER['REMOTE_ADDR'], 1))
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'You have no available rate limits, try again later.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		$s_u	= $this->network->get_user_by_id($source_id);
		$t_u	= $this->network->get_user_by_id($target_id);
		if(!$s_u || !$t_u)
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid user id.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		global $user;
		$user->logout();
		$user->login($s_u->username, $s_u->password); 
		if( ! $user->is_logged ) 
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage 4).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		$user_result = new stdClass;
		
		$stat = $user->if_follow_user($target_id);
		if($stat) $user_result->source_follow_target = 'true'; 
			else $user_result->source_follow_target = 'false';		
		
		$user->logout();
		$user->login($t_u->username, $t_u->password); 
		if( ! $user->is_logged ) 
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		$stat = $user->if_follow_user($source_id);
		if($stat) $user_result->target_follow_source = 'true'; else $stat='false';				

		$answer = generate_header($format, $callback, $s_u->id);
		$answer .= generate_it_en($format);			
			$answer .= generate_section($format, 'relationship');
		
				$answer .= generate_section($format, 'source');	
					$answer .= generate_field($format, 'id', $source_id);
					$answer .= generate_field($format, 'screen_name', $s_u->username);
					$answer .= generate_field($format, 'following', $user_result->source_follow_target);	
					$answer .= generate_field($format, 'followed_by', $user_result->target_follow_source);
					$answer = ($format == 'json')? substr($answer, 0, -1) : $answer;			
				$answer .= generate_section($format, 'source', TRUE);
			
				$answer .= generate_section($format, 'target', TRUE);
					$answer .= generate_field($format, 'id', $target_id);
					$answer .= generate_field($format, 'screen_name', $t_u->username);
					$answer .= generate_field($format, 'following', $user_result->target_follow_source);
					$answer .= generate_field($format, 'followed_by', $user_result->source_follow_target);
					$answer = ($format == 'json')? substr($answer, 0, -1) : $answer;	
				$answer .= generate_section($format, 'target', TRUE);
		
			$answer .= generate_section($format, 'relationship', TRUE);
		$answer .= generate_it_en($format, TRUE);
		$answer .= generate_bottom($format, $callback);
			
		echo $answer;
		exit;	
	
	}elseif($uri[0] == 'incoming')
	{
		if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
		else echo generate_error($format, 'Not implemented feature. Contact our support team for more information.', $_SERVER['REQUEST_URI'], $callback);
		
		exit;			
	}elseif($uri[0] == 'outgoing')
	{
		if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
		else echo generate_error($format, 'Not implemented feature. Contact our support team for more information.', $_SERVER['REQUEST_URI'], $callback);
		
		exit;	
	}
	
	if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 404 Not Found');
		else echo generate_error($format, 'Invalid resource request', $_SERVER['REQUEST_URI'], $callback);
	exit;	
?>