<?php
	require_once( $C->INCPATH.'helpers/func_api.php' );
	require_once( $C->INCPATH.'classes/class_oauth.php' );
	
	$uri = $this->param('more');
	$format = $this->param('format');
	
	$oauth_status = false;	

	if(! $header = prepare_header()) $oauth_error = 'Invalid Authorization header.';
	elseif(isset($header['oauth_version']) && $header['oauth_version'] != '1.0') $oauth_error = 'Not supported OAuth version';
	elseif(isset($header['oauth_consumer_key'], $header['oauth_nonce'], $header['oauth_token'],
			$header['oauth_signature_method'], $header['oauth_signature'], $header['oauth_timestamp']))
	{	
		$oauth_client = new OAuth($header['oauth_consumer_key'], $header['oauth_nonce'], $header['oauth_token'],
			$header['oauth_timestamp'], $header['oauth_signature']);
			
		$oauth_client->set_variable('stage_url', $C->SITE_URL.'1/groups');
		
		if($oauth_client->is_valid_get_resource_request())
		{
			if($header['oauth_signature_method'] != 'HMAC-SHA1') $oauth_error = 'Unsupported signature method';
			elseif(!$oauth_client->decrypt_hmac_sha1()) $oauth_error = 'Invalid signature';		
			else
			{
				$oauth_status = true;
			}
		}$oauth_error =  $oauth_client->get_variable('error_msg');		
	}else $oauth_error = 'Missing OAuth parameters';
	
	if(isset($_REQUEST['callback']) && valid_fn($_REQUEST['callback'])) $callback = $_REQUEST['callback'];
		else $callback = FALSE;
	$features = array('follow', 'unfollow', 'membership', 'all_groups', 'new', 'destroy');

	if($format != 'xml' && $format != 'json')
	{		
		if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
			else echo generate_error('xml', 'Invalid data format requested.', $_SERVER['REQUEST_URI'], $callback);

		exit;
	}elseif(!isset($uri[0]) || !in_array($uri[0], $features))
	{
		if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
			else echo generate_error($format, 'Invalid feature requested.', $_SERVER['REQUEST_URI'], $callback);
		exit;
	}elseif(($uri[0] == 'follow' || $uri[0] == 'unfollow') && isset($uri[1]))
	{
		if($_SERVER['REQUEST_METHOD'] != 'POST')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid request method.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_status)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
				else echo generate_error($format, 'OAuth otorization problem: '.$oauth_error, $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
										'access_token', urldecode($header['oauth_token'])));
		if(!$id)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		if(!$oauth_client->check_access_type('rw'))
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Forbidden');
				else echo generate_error($format, 'You have no permission for this action.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(is_numeric($uri[1])) $group_id = intval($uri[1]);
		else
		{
			$res = $db2->query('SELECT id FROM groups WHERE groupname=\''.$db2->e(urldecode($uri[1])).'\' LIMIT 1');
			if(!$db2->num_rows($res))
			{
				if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'Invalid group name.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			$res = $db2->fetch_object($res);
			$group_id = $res->id;
		}
			
		$u = $this->network->get_user_by_id($id);
		if(!$u)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid user.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		global $user;
		$user->logout();
		$user->login($u->username, $u->password); 
		if( ! $user->is_logged ) 
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage 1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if($uri[0] == 'follow') $ok = $user->follow_group($group_id);
		elseif($uri[0] == 'unfollow') $ok = $user->follow_group($group_id, FALSE);
		
		if($ok)
		{
			$answer = generate_header($format, $callback, $id);	
				$answer .= generate_section($format, 'user');					
					$answer .= print_user($id, $format);
						$q = 'SELECT id AS pid FROM posts WHERE user_id=\''.intval($id).'\' ORDER BY date DESC LIMIT 1';
						$answer .= generate_section($format, 'status');
							$answer .= print_status(0, $format, $q);
						$answer .= generate_section($format, 'status', TRUE);				
				$answer .= generate_section($format, 'user', TRUE);
			$answer .= generate_bottom($format, $callback);
			
			echo $answer;
			exit;
		}else
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'You can not follow/unfollow this group.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}		
	}elseif(($uri[0] == 'membership'))
	{
		if($_SERVER['REQUEST_METHOD'] != 'GET')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid request method.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(isset($uri[1]) && is_numeric($uri[1])) $id = intval($uri[1]);
		elseif(isset($uri[1]))
		{
			$q = 'SELECT id FROM groups WHERE groupname=\''.$db2->e($uri[1]).'\' AND is_public';
			
			$res = $db2->query($q);
			if($db2->query($res) > 0)
			{
				$res = $db2->fetch_object($res);
				$id = $res->id;
			}else
			{
				if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 304 Not Modified');
					else echo generate_error($format, 'No results found.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
		}
		else
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Parameter required.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		$q = 'SELECT groups_followed.user_id AS user FROM groups_followed, groups, users';
		$q .= ' WHERE groups_followed.user_id=users.id AND groups_followed.group_id=groups.id ';
		$q .= '  AND groups_followed.group_id='.intval($id);
		
		$res = $db2->query($q);
		
		if($db2->num_rows($res) > 0)
		{
			$answer = generate_header($format, $callback, $id);	
			
			while($obj = $db2->fetch_object($res))
			{	
				$answer .= generate_section($format, 'users');				
					$answer .= print_user($obj->user, $format);
					
					$answer .= generate_section($format, 'status');		
						$q = 'SELECT id AS pid FROM posts WHERE user_id=\''.$obj->user.'\' ORDER BY date DESC LIMIT 1';
						$answer .=  print_status(0, $format, $q);	
					$answer .= generate_section($format, 'status', TRUE);		
				
				$answer .= generate_section($format, 'users', TRUE);		
			}
					
			$answer .= generate_bottom($format, $callback);
			
			echo $answer;
			exit;
		}else
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 403 Not Modified');
				else echo generate_error($format, 'No results found.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
	
	}elseif(($uri[0] == 'all_groups'))
	{
		if($_SERVER['REQUEST_METHOD'] != 'GET')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid request method.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		$res = $db2->query('SELECT id, groupname FROM groups WHERE groups.is_public');
		
		$answer = generate_header($format, $callback);		
			$answer .= generate_section($format, 'groups');
				while($obj = $db2->fetch_object($res))
				{	
					$answer .= generate_section($format, 'group');		
						$answer .= generate_field($format, 'id', $obj->id);
						$answer .= generate_field($format, 'name', $obj->groupname);
						$answer = ($format == 'json')? substr($answer, 0, -1) : $answer;		
					$answer .= generate_section($format, 'group', TRUE);			
				}
			$answer .= generate_section($format, 'groups', TRUE);			
		$answer .= generate_bottom($format, $callback);
		
		echo $answer;
		exit;
					
	}elseif($uri[0] == 'create')
	{
		if($_SERVER['REQUEST_METHOD'] != 'POST')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid request method.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_status)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
				else echo generate_error($format, 'OAuth otorization problem: '.$oauth_error, $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
										'access_token', urldecode($header['oauth_token'])));
		if(!$id)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if(!$oauth_client->check_rate_limits($id, 1))
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 403 Forbidden');
				else echo generate_error($format, 'You have no available rate limits, try again later.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		if(!$oauth_client->check_access_type('rw'))
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Forbidden');
				else echo generate_error($format, 'You have no permission for this action.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		$error	= FALSE;
		$errmsg	= '';
		
		if(isset($_POST['title'], $_POST['groupname'], $_POST['description'], $_POST['type'])
			&& ($_POST['type'] == 'private' || $_POST['type'] == 'public'))
		{
			$form_title		= trim(htmlspecialchars(urldecode($_POST['title'])));
			$form_groupname	= trim(htmlspecialchars(urldecode($_POST['groupname'])));
			$form_description	= mb_substr(trim(htmlspecialchars(urldecode($_POST['description']))), 0, $C->POST_MAX_SYMBOLS);
			$form_type		= trim(htmlspecialchars(urldecode($_POST['type'])))=='private' ? 'private' : 'public';
		}else
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid group parameter.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if( mb_strlen($form_title)<3 || mb_strlen($form_title)>30 ) 
		{
			$error	= TRUE;
			$errmsg	= 'Not valid group name.';
		}
		elseif( preg_match('/[^א-תÀ-ÿ一-龥а-яa-z0-9\-\.\s]/iu', $form_title) ) 
		{
			$error	= TRUE;
			$errmsg	= 'Invalid group\'s name characters';
		}
		else 
		{
			$db2->query('SELECT id FROM groups WHERE (groupname="'.$db2->e($form_title).'" OR title="'.$db2->e($form_title).'") LIMIT 1');
			if( $db2->num_rows() > 0 ) 
			{
				$error	= TRUE;
				$errmsg	= 'Provide different group name.';
			}
		}
		
		if( !$error ) 
		{
			if( ! preg_match('/^[a-z0-9\-\_]{3,30}$/iu', $form_groupname) ) {
				$error	= TRUE;
				$errmsg	= 'Invalid group name.';
			}
			else 
			{
				$db2->query('SELECT id FROM groups WHERE (groupname="'.$db2->e($form_groupname).'" OR title="'.$db2->e($form_groupname).'") LIMIT 1');
				if( $db2->num_rows() > 0 ) 
				{
					$error	= TRUE;
					$errmsg	= 'Provide different group name.';
				}
				else 
				{
					$db2->query('SELECT id FROM users WHERE username="'.$db2->e($form_groupname).'" LIMIT 1');
					if( $db2->num_rows() > 0 ) 
					{
						$error	= TRUE;
						$errmsg	= 'Provide different group name.';
					}
					elseif( file_exists($C->INCPATH.'controllers/'.strtolower($form_groupname).'.php') ) 
					{
						$error	= TRUE;
						$errmsg	= 'Provide different group name.';
					}
					elseif( file_exists($C->INCPATH.'controllers/mobile/'.strtolower($form_groupname).'.php') ) 
					{
						$error	= TRUE;
						$errmsg	= 'Provide different group name.';
					}
				}
			}
		}else
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, $errmsg, $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if( ! $error ) 
		{
			$q = 'INSERT INTO groups SET groupname="'.$db2->e($form_groupname).'", title="'.$db2->e($form_title).'",';
			$q .= ' about_me="'.$db2->e($form_description).'", is_public="'.($form_type=='public'?1:0).'"';
			$db2->query($q);
			
			$g = $this->network->get_group_by_id(intval($db2->insert_id()));
			
			$db2->query('INSERT INTO groups_admins SET group_id="'.$g->id.'", user_id="'.$id.'" ');
			if( $g->is_private ) 
			{
				$q = 'INSERT INTO groups_private_members SET group_id="'.$g->id.'", user_id="'.$id.'",';
				$q .= ' invited_by="'.$id.'", invited_date="'.time().'"';
				
				$db2->query($q);
			}
			
			$u	= $this->network->get_user_by_id($id);
			if(!$u)
			{
				if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'Invalid user id.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			
			global $user;
			$user->logout();
			$user->login($u->username, $u->password); 
			if( ! $user->is_logged ) 
			{
				if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
					else echo generate_error($format, 'Server error.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			
			$ok = $user->follow_group($g->id);	
			if( $g->is_public ) 
			{
				$n	= intval( $this->network->get_user_notif_rules($id)->ntf_them_if_i_create_grp );
				if( $n == 1 ) 
				{
					$this->load_langfile('inside/notifications.php');
					$this->load_langfile('email/notifications.php');
					$followers	= array_keys($this->network->get_user_follows($id)->followers);
					foreach($followers as $uid) 
					{
						$send_post	= FALSE;
						$send_mail	= FALSE;
						$n	= intval( $this->network->get_user_notif_rules($uid)->ntf_me_if_u_creates_grp );
						if( $n == 2 ) { $send_post = TRUE; } elseif( $n == 3 ) { $send_mail = TRUE; } elseif( $n == 1 ) 
						{ $send_post = TRUE; $send_mail = TRUE; }
						
						if( $send_post ) 
						{
							$lng	= array('#USER#'=>'<a href="'.$C->SITE_URL.$u->username.'" title="'.htmlspecialchars($u->fullname).'"><span 						
							class="mpost_mentioned">@</span>'.$u->username.'</a>', 
							'#GROUP#'=>'<a href="'.$C->SITE_URL.$g->groupname.'" title="'.$g->title.'">'.$g->title.'</a>');
							$this->network->send_notification_post($uid, 0, 'msg_ntf_me_if_u_creates_grp', $lng, 'replace');
						}
						if( $send_mail ) 
						{
							$lng_txt	= array('#SITE_TITLE#'=>$C->SITE_TITLE, 
							'#USER#'=>'@'.$this->user->info->username, 
							'#NAME#'=>$u->fullname, '#GROUP#'=>$g->title, '#A0#'=>$C->SITE_URL.$g->groupname);
							
							$lng_htm	= array('#SITE_TITLE#'=>$C->SITE_TITLE, 
							'#USER#'=>'<a href="'.$C->SITE_URL.$u->username.'" 
							title="'.htmlspecialchars($u->fullname).'" target="_blank">@'.$u->username.'</a>', 
							'#NAME#'=>$u->fullname, 
							'#GROUP#'=>'<a href="'.$C->SITE_URL.$g->groupname.'" title="'.$g->title.'" target="_blank">'.$g->title.'</a>');
							
							$subject		= $this->lang('emlsubj_ntf_me_if_u_creates_grp', $lng_txt);
							$message_txt	= $this->lang('emltxt_ntf_me_if_u_creates_grp', $lng_txt);
							$message_htm	= $this->lang('emlhtml_ntf_me_if_u_creates_grp', $lng_htm);
							$this->network->send_notification_email($uid, 'u_creates_grp', $subject, $message_txt, $message_htm);
						}
					}
				}
			}
			$q = 'SELECT groupname AS gn, group_id AS gi FROM groups, groups_admins WHERE user_id ='.intval($id);
			$q .= ' ORDER BY groups_admins.id DESC LIMIT 1';
			
			$res = $db2->query($q);
			$obj = $db2->fetch_object($res);
			
			$answer = generate_header($format, $callback, $id);			
				$answer .= generate_section($format, 'group');					
					$answer .= generate_field($format, 'id', $obj->gi);
					$answer .= generate_field($format, 'name', $obj->gn);
					$answer = ($format == 'json')? substr($answer, 0, -1) : $answer;	
					
						$answer .= generate_section($format, 'user');					
							$answer .= print_user($id, $format);		
						$answer .= generate_section($format, 'user', TRUE);				
				$answer .= generate_section($format, 'group', TRUE);		
			$answer .= generate_bottom($format, $callback);
			
			echo $answer;
			exit;
		}else
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, $errmsg, $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
	}elseif(($uri[0] == 'destroy'))
	{
		if($_SERVER['REQUEST_METHOD'] != 'POST')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid request method.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_status)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
				else echo generate_error($format, 'OAuth otorization problem.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
										'access_token', urldecode($header['oauth_token'])));
		if(!$id)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if(!$oauth_client->check_rate_limits($id, 1))
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 403 Forbidden');
				else echo generate_error($format, 'You have no available rate limits, try again later.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		if(!$oauth_client->check_access_type('rw'))
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Forbidden');
				else echo generate_error($format, 'You have no permission for this action.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if(!isset($uri[1]) || !is_numeric($uri[1]))
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Provide valid group id.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		$q = 'SELECT 1 FROM groups_admins WHERE group_id='.intval($uri[1]).' AND user_id ='.intval($id).' LIMIT 1';
		$res = $db2->query($q);
		if($db2->num_rows($res) != 1)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
			else echo generate_error($format, 'You are not admin or only admin. You can not delete this group.', $_SERVER['REQUEST_URI'], $callback);
			
			exit;
		}

		$u	= $this->network->get_user_by_id($id);
		if(!$u)
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage 1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		global $user;
		$user->logout();
		$user->login($u->username, $u->password); 
		if( ! $user->is_logged ) 
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server Error (Stage D1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		ini_set('max_execution_time', 10*60*60);

		$r	= $db2->query('SELECT * FROM posts WHERE group_id="'.intval($uri[1]).'" ORDER BY id ASC');
		while($obj = $db2->fetch_object($r)) 
		{
			$p	= new post('public', FALSE, $obj);
			if( $p->error ) { continue; }
			$p->delete_this_post();
		}
		$r	= $db2->query('SELECT id FROM groups_rssfeeds WHERE group_id="'.intval($uri[1]).'" ');
		while($obj = $db2->fetch_object($r)) 
		{
			$db2->query('DELETE FROM groups_rssfeeds_posts WHERE rssfeed_id="'.$obj->id.'" ');
		}
		$db2->query('DELETE FROM groups_rssfeeds WHERE group_id="'.intval($uri[1]).'" ');

		$r	= $db2->query('SELECT * FROM posts WHERE user_id="0" AND group_id="'.intval($uri[1]).'" ORDER BY id ASC');
		while($obj = $db2->fetch_object($r)) 
		{
			$p	= new post('public', FALSE, $obj);
			if( $p->error ) { continue; }
			$p->delete_this_post();
		}
		$f	= array_keys($this->network->get_group_members(intval($uri[1])));
		$db2->query('DELETE FROM groups_followed WHERE group_id="'.intval($uri[1]).'" ');
		$db2->query('DELETE FROM groups_private_members WHERE group_id="'.intval($uri[1]).'" ');
		$db2->query('DELETE FROM groups_admins WHERE group_id="'.intval($uri[1]).'" ');
		$db2->query('UPDATE groups_rssfeeds SET is_deleted=1 WHERE group_id="'.intval($uri[1]).'" ');
		foreach($f as $uid) 
		{
			$this->network->get_user_follows($uid, TRUE);
		}
		$db2->query('INSERT INTO groups_deleted (id, groupname, title, is_public) SELECT id, groupname, title, 
					is_public FROM groups WHERE id="'.intval($uri[1]).'" LIMIT 1');
		$db2->query('DELETE FROM groups WHERE id="'.intval($uri[1]).'" LIMIT 1');

		$answer = generate_header($format, $callback, $id);	
				
			$answer .= generate_section($format, 'group');	
					$q = 'SELECT id, groupname, title FROM groups_deleted WHERE id='.intval($uri[1]).' LIMIT 1';				
					$answer .=  get_call_result($q, $format);
					
					$answer .= generate_section($format, 'user');					
						$answer .= print_user($id, $format);		
					$answer .= generate_section($format, 'user', TRUE);			
						
			$answer .= generate_section($format, 'group', TRUE);		

		$answer .= generate_bottom($format, $callback);
		
		echo $answer;
		exit;	
	}	
	if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 404 Not Found');
		else echo generate_error($format, 'Invalid resource request.', $_SERVER['REQUEST_URI'], $callback);
	exit;
?>