<?php
	require_once( $C->INCPATH.'helpers/func_api.php' );
	require_once( $C->INCPATH.'classes/class_oauth.php' );
	
	$uri = $this->param('more');
	$format = $this->param('format');
	setlocale(LC_TIME, 'en_US');
	
	$oauth_status = false;	

	if(! $header = prepare_header()) $oauth_error = 'Invalid Authorization header.';
	elseif(isset($header['oauth_version']) && $header['oauth_version'] != '1.0') $oauth_error = 'Not supported OAuth version';
	elseif(isset($header['oauth_consumer_key'], $header['oauth_nonce'], $header['oauth_token'],
			$header['oauth_signature_method'], $header['oauth_signature'], $header['oauth_timestamp']))
	{	
		$oauth_client = new OAuth($header['oauth_consumer_key'], $header['oauth_nonce'], $header['oauth_token'],
			$header['oauth_timestamp'], $header['oauth_signature']);
			
		$oauth_client->set_variable('stage_url', $C->SITE_URL.'1/saved_searches');
		
		if($oauth_client->is_valid_get_resource_request())
		{
			if($header['oauth_signature_method'] != 'HMAC-SHA1') $oauth_error = 'Unsupported signature method';
			elseif(!$oauth_client->decrypt_hmac_sha1()) $oauth_error = 'Invalid signature';		
			else
			{
				$oauth_status = true;
			}
		}$oauth_error =  $oauth_client->get_variable('error_msg');		
	}else $oauth_error = 'Missing OAuth parameters';
	
	if(isset($_REQUEST['callback']) && valid_fn($_REQUEST['callback'])) $callback = $_REQUEST['callback'];
		else $callback = FALSE;

	if(!$oauth_status)
	{
		if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
			else echo generate_error($format, 'OAuth otorization problem.', $_SERVER['REQUEST_URI'], $callback);
		exit;
	}elseif($format != 'xml' && $format != 'json')
	{		
		if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
			else echo generate_error('xml', 'Invalid data format requested.', $_SERVER['REQUEST_URI'], $callback);

		exit;
	}elseif(isset($uri[0]) && $uri[0] == 'create' ) 
	{
		if($_SERVER['REQUEST_METHOD'] != 'POST')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid request method.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_status)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
				else echo generate_error($format, 'OAuth otorization problem: '.$oauth_error, $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
										'access_token', urldecode($header['oauth_token'])));
		if(!$id)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		if(!$oauth_client->check_access_type('rw'))
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 403 Forbidden');
				else echo generate_error($format, 'You have no permission for this action.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!isset($_POST['query']) || empty($_POST['query']))
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid query parameter.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		$query	= trim(htmlspecialchars(urldecode($_POST['query'])));
		
		if(!$oauth_client->check_rate_limits($id, 1))
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'You have no available rate limits, try again later.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
				
		$db2->query('SELECT id, search_string, added_date FROM searches WHERE user_id="'.intval($id).'" AND search_string="'.$db2->e($query).'" LIMIT 1');
		if( $obj = $db2->fetch_object() ) 
		{
			$obj->id			= intval($obj->id);
			$obj->search_string	= stripslashes($obj->search_string);
			$obj->added_date		= gmstrftime('%a %b %d %H:%M:%S +0000 %Y', $obj->added_date);
		}else 
		{
			$obj	= new stdClass;
			$obj->search_string	= $query;
			$obj->added_date		= gmstrftime('%a %b %d %H:%M:%S +0000 %Y', time());
			$tmp_url	= trim($C->SITE_URL,'/');
			$tmp_url	= str_replace(array('http://','https://'),'',$tmp_url);
			$tmp_url	= '/'.trim($tmp_url,'/').'/search/tab:posts/s:'.urlencode($query);
			$search_key	= md5($query."\n".serialize(array('link','image','video','file'))."\n\n\n".serialize('')."\n".serialize(''));
			
			$q = 'INSERT INTO searches SET user_id="'.intval($id).'", search_key="'.$db2->e($search_key).'",';
			$q .= ' search_string="'.$db2->e($query).'", search_url="'.$db2->e($tmp_url).'", added_date="'.time().'",';
			$q .= ' total_hits=0, last_results=0';
			
			$db2->query( $q );
			$obj->id	= intval($db2->insert_id());
		}
		
		$answer = generate_header($format, $callback);			
		$answer .= generate_section($format, 'saved_search');
		
			$answer .= generate_field($format, 'id', $obj->id);
			
			$obj->search_string	= stripslashes($obj->search_string);
			$answer .= generate_field($format, 'query', $obj->search_string);
			
			$answer .= generate_field($format, 'created_at', $obj->added_date);	
			$answer = ($format=='json') ? $answer : substr($answer, 0, -1);
			
		$answer .= generate_section($format, 'saved_search', TRUE);
		$answer .= generate_bottom($format, $callback);
		echo $answer;
		exit;
	}
	elseif(isset($uri[0]) &&  $uri[0] == 'show' ) 
	{
		if($_SERVER['REQUEST_METHOD'] != 'GET')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid request method.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if(!$oauth_status)
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
				else echo generate_error($format, 'OAuth otorization problem: '.$oauth_error, $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
										'access_token', urldecode($header['oauth_token'])));
		if(!$id)
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if(!isset($uri[1]) || (isset($uri[1]) && !is_numeric($uri[1])))
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid parameter provided.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_client->check_rate_limits($id, 1))
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 403 Forbidden');
				else echo generate_error($format, 'You have no available rate limits, try again later.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		$db2->query('SELECT id, user_id, search_string, added_date FROM searches WHERE id="'.intval($uri[1]).'" AND user_id="'.intval($id).'" LIMIT 1');
		if($obj = $db2->fetch_object()) 
		{
			if($obj->user_id != $id)
			{
				if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'Invalid parameter provided.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			$obj->id			= intval($obj->id);
			$obj->search_string	= stripslashes($obj->search_string);
			$obj->added_date		= gmstrftime('%a %b %d %H:%M:%S +0000 %Y', $obj->added_date);
			
			$answer = generate_header($format, $callback);	
			$answer .= generate_it_en($format);		
			$answer .= generate_section($format, 'saved_search');
				$answer .= generate_field($format, 'id', $obj->id);
				
				$obj->search_string	= stripslashes($obj->search_string);
				$answer .= generate_field($format, 'query', $obj->search_string);
				
				$answer .= generate_field($format, 'created_at', $obj->added_date);	
				$answer = ($format=='json') ? substr($answer, 0, -1):$answer;
				
			$answer .= generate_section($format, 'saved_search', TRUE);
			$answer .= generate_it_en($format, TRUE);
			$answer .= generate_bottom($format, $callback);
			echo $answer;
			exit;
		}else
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 304 Not Modified');
				else echo generate_error($format, 'No results found.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
	}
	elseif(isset($uri[0]) &&  $uri[0] == 'destroy' ) 
	{
		if($_SERVER['REQUEST_METHOD'] != 'POST')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid request method.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if(!$oauth_status)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
				else echo generate_error($format, 'OAuth otorization problem.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
										'access_token', urldecode($header['oauth_token'])));
		if(!$id)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if(!$oauth_client->check_access_type('rw'))
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Forbidden');
				else echo generate_error($format, 'You have no permission for this action.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if((isset($uri[1]) && !is_numeric($uri[1])) || !isset($uri[1]))
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid parameter provided.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_client->check_rate_limits($id, 1))
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'You have no available rate limits, try again later.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		$db2->query('SELECT id, search_string, added_date FROM searches WHERE id="'.intval($uri[1]).'" AND user_id="'.intval($id).'" LIMIT 1');
		if($obj = $db2->fetch_object()) {
			$obj->id			= intval($obj->id);
			$obj->search_string	= stripslashes($obj->search_string);
			$obj->added_date		= gmstrftime('%a %b %d %H:%M:%S +0000 %Y', $obj->added_date);
			$db2->query('DELETE FROM searches WHERE id="'.$obj->id.'" LIMIT 1');
			
			$answer = generate_header($format, $callback, $id);
			$answer .= generate_it_en($format);			
			$answer .= generate_section($format, 'saved_search');
				$answer .= generate_field($format, 'id', $obj->id);
				
				$obj->search_string	= stripslashes($obj->search_string);
				$answer .= generate_field($format, 'query', $obj->search_string);
				
				$answer .= generate_field($format, 'created_at', $obj->added_date);		
				$answer = ($format=='json') ? substr($answer, 0, -1):$answer;
				
			$answer .= generate_section($format, 'saved_search', TRUE);
			$answer .= generate_it_en($format, TRUE);
			$answer .= generate_bottom($format, $callback);
			echo $answer;
			exit;
		}else
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 304 Not modified');
				else echo generate_error($format, 'No data deleted.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
	}
	elseif(isset($this->request[0]) && $this->request[0] == 'saved_searches')
	{
		if($_SERVER['REQUEST_METHOD'] != 'GET')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid request method.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_status)
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
				else echo generate_error($format, 'OAuth otorization problem: '.$oauth_error, $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
										'access_token', urldecode($header['oauth_token'])));
		if(!$id)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if(!$oauth_client->check_rate_limits($id, 1))
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'You have no available rate limits, try again later.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		$res = $db2->query('SELECT id, search_string, added_date FROM searches WHERE user_id="'.intval($id).'" ORDER BY id DESC');
		
		if($db2->num_rows($res) > 0)
		{
			$answer = generate_header($format, $callback, $id);			
			$answer .= generate_section($format, 'saved_searches type="array"');
			
				while($obj = $db2->fetch_object($res)) 
				{
					$answer .= generate_section($format, 'saved_search');
						$answer .= generate_field($format, 'id', $obj->id);
						
						$obj->search_string	= stripslashes($obj->search_string);
						$answer .= generate_field($format, 'query', $obj->search_string);
						
						$obj->added_date		= gmstrftime('%a %b %d %H:%M:%S +0000 %Y', $obj->added_date);
						$answer .= generate_field($format, 'created_at', $obj->added_date);
						
						$answer = ($format=='xml') ? $answer : substr($answer, 0, -1);		
					$answer .= generate_section($format, 'saved_search', TRUE);
				}
				
			$answer .= generate_section($format, 'saved_searches', TRUE);
			$answer .= generate_bottom($format, $callback);
			echo $answer;
			exit;
		}else
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 403 Not Modified');
				else echo generate_error($format, 'No results found.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
	}
	if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 404 Not Found');
		else echo generate_error($format, 'Invalid resource request', $_SERVER['REQUEST_URI'], $callback);
	exit;	
?>