<?php
	require_once( $C->INCPATH.'helpers/func_api.php' );
	require_once( $C->INCPATH.'classes/class_oauth.php' );
	
	$uri = $this->param('more');
	$format = $this->param('format');
	
	$oauth_status = false;	

	if(! $header = prepare_header()) $oauth_error = 'Invalid Authorization header.';
	elseif(isset($header['oauth_version']) && $header['oauth_version'] != '1.0') $oauth_error = 'Not supported OAuth version';
	elseif(isset($header['oauth_consumer_key'], $header['oauth_nonce'], $header['oauth_token'],
			$header['oauth_signature_method'], $header['oauth_signature'], $header['oauth_timestamp']))
	{	
		$oauth_client = new OAuth($header['oauth_consumer_key'], $header['oauth_nonce'], $header['oauth_token'],
			$header['oauth_timestamp'], $header['oauth_signature']);
			
		$oauth_client->set_variable('stage_url', $C->SITE_URL.'1/users');
		
		if($oauth_client->is_valid_get_resource_request())
		{
			if($header['oauth_signature_method'] != 'HMAC-SHA1') $oauth_error = 'Unsupported signature method';
			elseif(!$oauth_client->decrypt_hmac_sha1()) $oauth_error = 'Invalid signature';		
			else
			{
				$oauth_status = true;
			}
		}$oauth_error =  $oauth_client->get_variable('error_msg');		
	}else $oauth_error = 'Missing OAuth parameters';
	
	$features = array('show', 'lookup', 'search', 'suggestion');
	if(isset($_REQUEST['callback']) && valid_fn($_REQUEST['callback'])) $callback = $_REQUEST['callback'];
		else $callback = FALSE;

	if($format != 'xml' && $format != 'json')
	{		
		if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
			else echo generate_error('xml', 'Invalid data format requested.', $_SERVER['REQUEST_URI'], $callback);

		exit;
	}elseif(!isset($uri[0]) || !in_array($uri[0], $features))
	{
		if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
			else echo generate_error($format, 'Invalid feature requested.', $_SERVER['REQUEST_URI'], $callback);
		exit;
	}elseif($uri[0] == 'show')
	{
		if($_SERVER['REQUEST_METHOD'] != 'GET')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error('xml', 'Invalid request method or data format.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if(isset($_GET['user_id']) && is_numeric($_GET['user_id'])) $id = intval($_GET['user_id']);
		elseif(isset($_GET['screen_name']))
		{
			$u = $this->network->get_user_by_username(urldecode($_GET['screen_name']));
			if(!$u)
			{
				if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'Invalid username.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			$id = $u->id;
		}elseif(isset($uri[1]) && is_numeric($uri[1])) $id = intval($uri[1]);
		elseif(isset($uri[1]))
		{
			$u = $this->network->get_user_by_username(urldecode($uri[1]));
			if(!$u)
			{
				if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'Invalid username.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			$id = $u->id;
		}elseif($oauth_status)
		{
			$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
										'access_token', urldecode($header['oauth_token'])));
		}else
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Parameter required.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		$u = $this->network->get_user_by_id($id);
		if(!$u)
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid user id.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!check_rate_limits($_SERVER['REMOTE_ADDR'], 1))
		{
			if(!isset($_GET['suppress_response_codes'])) header('HTTP/1.1 403 Forbidden');
				else echo generate_error($format, 'You have no available rate limits, try again later.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		$answer = generate_header($format, $callback, $id);
			$answer .= generate_section($format, 'user');
				$answer .= print_user($id, $format);				
					$answer .= generate_section($format, 'status');				
					$q = 'SELECT posts.id  AS pid FROM posts, groups, users ';
					$q .= ' WHERE users.id=\''.intval($id).'\' AND users.id=posts.user_id ';
					$q .= ' AND (posts.group_id = 0 OR posts.group_id = groups.id) AND groups.is_public ';
					$q .= ' ORDER BY posts.date DESC LIMIT 1';
					$answer .= print_status(0, $format, $q);				
				$answer .= generate_section($format, 'status', TRUE);		
			$answer .= generate_section($format, 'user', TRUE);
		$answer .= generate_bottom($format, $callback);
		
		echo $answer;
		exit;
	}elseif($uri[0] == 'lookup')
	{
		if($_SERVER['REQUEST_METHOD'] != 'GET' && $_SERVER['REQUEST_METHOD'] != 'POST')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error('xml', 'Invalid request method or data format.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_status)
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
				else echo generate_error($format, 'OAuth otorization problem.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
										'access_token', urldecode($header['oauth_token'])));
		if(!$id)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_client->check_rate_limits($id, 1))
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 403 Forbidden');
				else echo generate_error($format, 'You have no available rate limits, try again later.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		$answer = generate_header($format, $callback);	
		
		if(isset($_REQUEST['user_id']))
		{
			$user_ids = explode(',', urldecode($_REQUEST['user_id']));

			if(count($user_ids) > 0)
			{
				foreach($user_ids as $user)
				{
					$answer .= generate_section($format, 'user');
						$answer .= print_user($user, $format);
						$answer .= generate_section($format, 'status');
							$q = 'SELECT posts.id  AS pid FROM posts, groups, users ';
							$q .= ' WHERE users.id=\''.intval($user).'\' AND users.id=posts.user_id ';
							$q .= ' AND (posts.group_id = 0 OR posts.group_id = groups.id) AND groups.is_public ';
							$q .= ' ORDER BY posts.date DESC LIMIT 1';
							$answer .= print_status(0, $format, $q);
						$answer .= generate_section($format, 'status', TRUE);
					$answer .= generate_section($format, 'user', TRUE);
				}
			}	
		}
		if(isset($_REQUEST['screen_name']))
		{
			$user_names = explode(',', urldecode($_REQUEST['screen_name']));
			
			if(count($user_names) > 0)
			{
				foreach($user_names as $user)
				{
					$u = $this->network->get_user_by_username($user);
					if(!$u) continue;
					$answer .= generate_section($format, 'user');
						$answer .= print_user($u->id, $format);			
							$answer .= generate_section($format, 'status');
							$q = 'SELECT posts.id  AS pid FROM posts, groups, users ';
							$q .= ' WHERE users.id=\''.intval($u->id).'\' AND users.id=posts.user_id ';
							$q .= ' AND (posts.group_id = 0 OR posts.group_id = groups.id) AND groups.is_public ';
							$q .= ' ORDER BY posts.date DESC LIMIT 1';
							$answer .= print_status(0, $format, $q);
						$answer .= generate_section($format, 'status', TRUE);
					$answer .= generate_section($format, 'user', TRUE);
				}
			}
		}
		$answer .= generate_bottom($format, $callback);
		echo $answer;
		exit;
	}elseif($uri[0] == 'search')
	{
		if($_SERVER['REQUEST_METHOD'] != 'GET' && $_SERVER['REQUEST_METHOD'] != 'POST')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error('xml', 'Invalid request method or data format.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_status)
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
				else echo generate_error($format, 'OAuth otorization problem.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
										'access_token', urldecode($header['oauth_token'])));
		if(!$id)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_client->check_rate_limits($id, 1))
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 403 Forbidden');
				else echo generate_error($format, 'You have no available rate limits, try again later.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!isset($_REQUEST['q']) || empty($_REQUEST['q']))
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Query parameter required.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}else $_REQUEST['q'] = urldecode($_GET['q']);
		
		$q = 'SELECT id, username FROM users WHERE username LIKE \'%'.$db2->e($_REQUEST['q']).'%\'';
		if(isset($_REQUEST['page']) && is_numeric($_REQUEST['page']))
		{		
			if(isset($_REQUEST['per_page']) && is_numeric($_REQUEST['per_page']) && $_REQUEST['per_page']<=20)
			$q .= ' LIMIT '.intval($_REQUEST['per_page'])*(intval($_REQUEST['page'])-1).', '.(intval($_REQUEST['per_page']))*(intval($_REQUEST['page']));
			else 
			$q .= ' LIMIT '.(20)*(intval($_REQUEST['page'])-1).', '.(20)*(intval($_REQUEST['page']));
		}
		elseif(isset($_GET['per_page']) && is_numeric($_REQUEST['per_page']) && $_REQUEST['per_page']<=20)
			$q .= ' LIMIT '.intval($_REQUEST['per_page']);

		$res = $db2->query($q);
	
		if($db2->num_rows($res)>0)
		{
			$answer = generate_header($format, $callback, $id);			
			while($user = $db2->fetch_object($res))
			{
				$answer .= generate_section($format, 'user');
					$answer .= print_user($user->id, $format);
						$answer .= generate_section($format, 'status');
							$q = 'SELECT posts.id  AS pid FROM posts, groups, users ';
							$q .= ' WHERE users.id=\''.intval($user->id).'\' AND users.id=posts.user_id ';
							$q .= ' AND (posts.group_id = 0 OR posts.group_id = groups.id) AND groups.is_public ';
							$q .= ' ORDER BY posts.date DESC LIMIT 1';
							$answer .= print_status(0, $format, $q);	
						$answer .= generate_section($format, 'status', TRUE);			
				$answer .= generate_section($format, 'user', TRUE);
			}
			$answer .= generate_bottom($format, $callback);
			echo $answer;
			exit;	
		}else
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 304 Not Modified');
				else echo generate_error($format, 'No Results found.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}		
	}elseif($uri[0] == 'suggestion' && isset($uri[1]) && $uri[1] == 'category')
	{
		if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
		else echo generate_error($format, 'Not implemented feature. Contact our support team for more information.', $_SERVER['REQUEST_URI'], $callback);
		
		exit;	
	}elseif($uri[0] == 'suggestion')
	{
		if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
		else echo generate_error($format, 'Not implemented feature. Contact our support team for more information.', $_SERVER['REQUEST_URI'], $callback);
		
		exit;		
	}elseif(($uri[0] == 'groups'))
	{
		if($_SERVER['REQUEST_METHOD'] != 'GET' && $_SERVER['REQUEST_METHOD'] != 'POST')
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Invalid request method or data format.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(!$oauth_status)
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 401 Unauthorized');
				else echo generate_error($format, 'OAuth otorization problem.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		$id = intval($oauth_client->get_field_in_table('oauth_access_token', 'user_id', 
										'access_token', urldecode($header['oauth_token'])));
		if(!$id)
		{
			if(!isset($_POST['suppress_response_codes'])) header('HTTP/1.1 500 Internal Server Error');
				else echo generate_error($format, 'Server error (Stage C1).', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
		
		if(!$oauth_client->check_rate_limits($id, 1))
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 403 Forbidden');
				else echo generate_error($format, 'You have no available rate limits, try again later.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}

		if(isset($uri[1]) && is_numeric($uri[1])) $id = intval($uri[1]);
		elseif(isset($uri[1]))
		{
			$u = $this->network->get_user_by_username(urldecode($uri[1]));
			if(!$u)
			{
				if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
					else echo generate_error($format, 'Invalid username.', $_SERVER['REQUEST_URI'], $callback);
				exit;
			}
			$id = $u->id;
		}
		else
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 400 Bad Request');
				else echo generate_error($format, 'Parameter required.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}
			 
		$q = 'SELECT groups.groupname AS gn, groups_followed.group_id AS gi FROM groups_followed, groups, users';
		$q .= ' WHERE groups_followed.user_id=users.id AND groups_followed.group_id=groups.id AND groups.is_public ';
		$q .= '  AND groups_followed.user_id='.intval($id).' GROUP BY groups.id';
		
		$res = $db2->query($q);
		if($db2->num_rows($res) > 0)
		{	
			$answer = generate_header($format, $callback, $id);	
			$answer .= generate_section($format, 'groups');		
				while($obj = $db2->fetch_object($res))
				{	
					$answer .= generate_section($format, 'group');		
						$answer .= generate_field($format, 'id', $obj->gi);
						$answer .= generate_field($format, 'name', $obj->gn);
						$answer = ($format == 'json')? substr($answer, 0, -1) : $answer;		
					$answer .= generate_section($format, 'group', TRUE);			
				}
			$answer .= generate_section($format, 'groups', TRUE);			
			$answer .= generate_bottom($format, $callback);
			
			echo $answer;
			exit;	
		}else
		{
			if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 403 Not Modified');
				else echo generate_error($format, 'No results found.', $_SERVER['REQUEST_URI'], $callback);
			exit;
		}	
	}
	
	if(!isset($_REQUEST['suppress_response_codes'])) header('HTTP/1.1 404 Not Found');
		else echo generate_error($format, 'Invalid resource request', $_SERVER['REQUEST_URI'], $callback);
	exit;		
?>